#! /usr/bin/ruby
#= Metasequoia ގבւXNvg

def sort_mat(in_file, out_file = in_file.gsub(/\.mqo$/i,'-sort.mqo'))
   open(out_file,'w'){|out|
      mat_array = []
      mat_map = []
      mat_id = 0
      state = :search_mat_chunk
      IO.readlines(in_file).each{|line|
         case state
         when :search_mat_chunk
            if line =~ /^Material (\d+) \{/
               state = :get_mat_array
               mat_array = Array.new($1.to_i)
               mat_map = Array.new($1.to_i)
               mat_id = 0
            end
            out.print line
         when :get_mat_array
            case line
            when /\t\".+\" col/
               mat_array[mat_id] = [mat_id, line]
               mat_id += 1
               next
            when /^\}/
               state = :change_mat
               mat_array.sort!{|x,y| x[1] <=> y[1]}
               mat_array.each_with_index{|x,i|
                  mat_map[x[0]] = i
                  out.print x[1]
               }
            end
            out.print line
         when :change_mat
            case line
            when /\t\t\d V\(.*\) M\((\d+)\)/
               mat_id = mat_map[$1.to_i]
               out.print line.gsub(/ M\(\d+\)/," M(#{mat_id})")
            else
               out.print line
            end
         end
      }
   }
end

ARGV.reject!{|x| !(x =~ /\.mqo$/i)}
ARGV.each{|x|
   sort_mat(x)
}
