#! /usr/bin/ruby
#= Ruby/MetaRed: MetasequoiaRedqueen2ϊXNvg(mqo2rq2-scn.rb)
# IuWFNg͕ϊȂ

require 'mqo2rq2'

module Metasequoia
   class Transcoder < Loader
      def object_chunk_start(obj_name)
         return nil
      end
      def vertex_chunk_start(vnum)
         return nil
      end
      def vertexattr_chunk_start()
         return nil
      end
      def weit_chunk_start()
         return nil
      end
      def face_chunk_start(fnum)
         return nil
      end
      # `N̏ICxg
      def chunk_end
         print "#{@parent.last.class} <- #{@current.class}\n" if $Debug
         case @current
         when Scene, MaterialChunk
            @current.fputs(@opts, @out)
         end
      end
      def vertex_value(x, y, z)
      end
      def weit_value(vid, weit)
      end
      def face_value(vnum, vtx, mat_id, uv_ary, vcol)
      end
   end

   def self.transcode(infile, opts = {})
      raise FormatError unless infile =~ /\.mqo$/i
      outfile = infile.gsub(/\.mqo$/i, '-scn.rrt')
      opts[:tracedepth] ||= 5
      opts[:gisample] ||= 16
      opts[:photonsearchradius] ||= 1
      opts[:width] ||= 640
      opts[:height] ||= 480
      opts[:oversampling] ||= 5
      opts[:bgtype] ||= 'colored'
      $scale = (opts[:scaling] ||= 0.1)
      $c_scale = (opts[:camera_scaling] ||= $scale)
      mqoLD = Transcoder.new(infile, outfile, opts)
      return mqoLD.transcode
   end
end

#= PƂŌĂяoꂽꍇ̂ݗLȏB
# CuƂČĂяoꂽꍇɂ͖B
if $0 == __FILE__
   def mqo2rrt(file_name, opts)
      return Metasequoia.transcode(file_name, opts)
   end
   def uv(u, v)
      Redqueen2::UV.new(u.to_i, v.to_i)
   end
   def xyz(x, y, z)	# Metasequoia̍Wnœ͂Rq2̍WnŕԂ
      Redqueen2::Vector.new(x.to_f, -z.to_f, y.to_f)
   end
   def rgb(r, g, b)
      Redqueen2::Color.new(r.to_f, g.to_f, b.to_f)
   end
   def parallelLight(col, dir, photon, blur)
      Redqueen2::ParallelLight.new(col, dir, photon, blur)
   end

   require 'optparse'
   # ͌ʂ邽߂Hashm
   RRT = {}
   white = rgb(1.0, 1.0, 1.0)
   gray  = rgb(0.6, 0.6, 0.6)
   black = rgb(0.0, 0.0, 0.0)

   RRT[:default_lights] = true
   begin
      load 'mqo2rq2.cfg'	# ftHgݒt@CΓǂݍ
   rescue LoadError
   end

   ARGV.options{|opts|
      opts.banner = "Usage: #{$0} [options] mqo_file ...\n"

      opts.on_head("normal options:")

      opts.on("-x", "--width=WIDTH", Integer, ":integer [640]") {|RRT[:width]|
         RRT[:width] ||= 640
      }

      opts.on("-y", "--height=HEIGHT", Integer, ":integer [480]") {|RRT[:height]|}

      opts.on("-o", "--oversampling=SAMPLE", Integer, ":integer [3]") {|RRT[:oversampling]|}

      opts.on("-d", "--tracedepth=DEPTH", Integer, ":integer [5]") {|RRT[:tracedepth]|}

      opts.on("--scaling=SCALING", Float, ":float [0.1]") {|RRT[:scaling]|
         $MQOtoRRT_Scaling = RRT[:scaling]
      }

      opts.on("--no-default-lights", "") {|RRT[:default_lights]|}

      opts.on # separator
      opts.on("background options:")

      opts.on("--bgcolor=R,G,B", Array, ":float,float,float [MQO ambient color]") {|r, g, b|
         # Array̒g`FbN
         raise OptionParser::InvalidOption unless r =~ /^(\d+\.)?\d+$/
         raise OptionParser::InvalidOption unless g =~ /^(\d+\.)?\d+$/
         raise OptionParser::InvalidOption unless b =~ /^(\d+\.)?\d+$/
         RRT[:bgcolor] = Redqueen::Vector3.new(r.to_f, g.to_f, b.to_f)
      }
      opts.on("--hdri=HDRI_FILE", String, ":*.pfm, *.png, *.ppm, *.tif") {|RRT[:hdri]|}
      opts.on("--patch=PATCH_FILE", String, ':loading patch file for mqo2rq.rb') {|pat|
         begin
            require pat
         rescue LoadError
         end
      }

      opts.on_tail # separater
      opts.on_tail("common options:")
      opts.on_tail("-?", "--help", "show this message") {puts opts; exit}
      opts.on_tail # separater
      opts.on_tail("If exists 'mqo2rq2.cfg' in current folder then preload it.")
      opts.parse!
   } or (puts "\n", ARGV.options; exit 1)

   ARGV.reject!{|x|
      !(/\.mqo$/i =~ x)
   }
   (puts ARGV.options; exit) if ARGV.empty?
   ARGV.options = nil	# no more parse

   ARGV.each{|fn|
      if mqo2rrt(fn, RRT)
         GC.start
      end
   }
end
